---
published: true
permalink: /algorithm/baekjoon-acmicpc-1302
comments: true
categories:
  - algorithm
title: '[BaekJoon] 1302. # 베스트셀러'
---
[BaekJoon] 1302. # 베스트셀러


## Question

김형택은 탑문고의 직원이다. 김형택은 계산대에서 계산을 하는 직원이다. 김형택은 그날 근무가 끝난 후에, 오늘 판매한 책의 제목을 보면서 가장 많이 팔린 책의 제목을 칠판에 써놓는 일도 같이 하고 있다.

오늘 하루 동안 팔린 책의 제목이 입력으로 들어왔을 때, 가장 많이 팔린 책의 제목을 출력하는 프로그램을 작성하시오.

### 입력
첫째 줄에 오늘 하루 동안 팔린 책의 개수 N이 주어진다. 이 값은 1,000보다 작거나 같은 자연수이다. 둘째부터 N개의 줄에 책의 제목이 입력으로 들어온다. 책의 제목의 길이는 50보다 작거나 같고, 알파벳 소문자로만 이루어져 있다.

### 출력
첫째 줄에 가장 많이 팔린 책의 제목을 출력한다. 만약 가장 많이 팔린 책이 여러 개일 경우에는 사전 순으로 가장 앞서는 제목을 출력한다.

## Solution
```java
import java.io.BufferedReader; 
import java.io.InputStreamReader;
import java.util.Hashtable;
import java.util.ArrayList;
import java.util.Collections;

public class Main { 
    public static void main(String[] args) throws Exception { 
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        int N = Integer.parseInt(br.readLine());
        
        Hashtable<String, Integer> bookTables = new Hashtable<String, Integer>();

        String firstRank = ""; 
        int firstRankBookSales = 0; 
        
        for (int i = 0; i < N; i ++) {
            String book = br.readLine();

            // bookTables 정리 (도서명, 판매건수)
            if (bookTables.containsKey(book)) {
                bookTables.put(book, bookTables.get(book) + 1);
            }
            else {
                bookTables.put(book, 1);
            }
            
            // 가장 많이 팔리는 책 찾기 
            if (firstRankBookSales <= bookTables.get(book))
            {
                 if (firstRankBookSales == bookTables.get(book))
                     firstRank = (firstRank.compareTo(book) > 0 ? book : firstRank);
                 else        
                     firstRank = book; 
                
                 firstRankBookSales = bookTables.get(book); 
             }
        }
        
        System.out.println(firstRank);        
    } 
}
```


## Learning... 
- java 문법 
  - [Hashtable](https://soo-toance.github.io/java/hashtable)
  - [BufferedReader](https://soo-toance.github.io/java/bufferedreader)
  - [String.compareTo](https://soo-toance.github.io/java/string)
  


## Reference
- [BaekJoon](https://www.acmicpc.net/problem/1302)
