---
published: true
permalink: /algorithm/baekjoon-acmicpc-2110
comments: true
categories:
  - algorithm
title: '[BaekJoon] 2110. # 공유기 설치'
---
[BaekJoon] 2110. # 공유기 설치 


## Question

도현이의 집 N개가 수직선 위에 있다. 각각의 집의 좌표는 x1, ..., xN이고, 집 여러개가 같은 좌표를 가지는 일은 없다.

도현이는 언제 어디서나 와이파이를 즐기기 위해서 집에 공유기 C개를 설치하려고 한다. 최대한 많은 곳에서 와이파이를 사용하려고 하기 때문에, 한 집에는 공유기를 하나만 설치할 수 있고, 가장 인접한 두 공유기 사이의 거리를 가능한 크게 하여 설치하려고 한다.

C개의 공유기를 N개의 집에 적당히 설치해서, 가장 인접한 두 공유기 사이의 거리를 최대로 하는 프로그램을 작성하시오.


### 입력
첫째 줄에 집의 개수 N (2 ≤ N ≤ 200,000)과 공유기의 개수 C (2 ≤ C ≤ N)이 하나 이상의 빈 칸을 사이에 두고 주어진다. 둘째 줄부터 N개의 줄에는 집의 좌표를 나타내는 xi (1 ≤ xi ≤ 1,000,000,000)가 한 줄에 하나씩 주어진다.


### 출력
첫째 줄에 가장 인접한 두 공유기 사이의 최대 거리를 출력한다.


## Solution
### 풀이 
집의 좌표가 10억 단위이기 때문에 하나하나 검색할 경우 O(N)이 걸리기 때문에 다른 방법으로 검색해야 한다.
이 문제의 경우 "이진 검색"으로 진행하였다. 


```java
import java.util.Scanner; 
import java.util.Arrays;  
public class Main { 
    public static void main(String[] args) throws Exception { 
        Scanner scn = new Scanner(System.in);
        int N = scn.nextInt(); // 집의 개수
        int C = scn.nextInt(); // 공유기의 개수 
        int[] home = new int[N];
        
        // 집 데이터 저장 
        for (int i = 0; i < N; i++)
            home[i] = scn.nextInt();
        Arrays.sort(home);
        
        
        int minGap = 1; 
        int maxGap = home[N - 1] - home[0]; 
        int minDistance = 0; 
        
        while (minGap <= maxGap) {
            int midGap = (minGap + maxGap) / 2;
            
            int prev = home[0]; // 라우터 첫번째 설치 
            int countRouter = 1; 
            for (int i = 1; i < N; i ++) {
                if (home[i] - prev >= midGap) {
                    countRouter++;
                    prev = home[i];
                }
            }
            
            // 라우터 설치 개수가 C보다 작으면 => gap을 줄여서 라우터를 더 추가 (max를 줄임)
            // 라우터 설치 개수가 C보다 크거나 같으면 => 조건 만족하므로 값 저장. gap을 늘려봄. 
            if (countRouter < C)
                maxGap = midGap - 1; 
            else 
            {
                minDistance = midGap; 
                minGap = midGap + 1; 
            }
        }
        System.out.println(minDistance);
    } 
}
```


## Learning... 
- 이진탐색 (작성예정) 
  


## Reference
- [BaekJoon](https://www.acmicpc.net/problem/2110)
