---
published: true
permalink: /algorithm/baekjoon-acmicpc-1991
comments: true
categories:
  - algorithm
title: '[BaekJoon] 1991. # 트리 순회'
---
[BaekJoon] 1991. # 트리 순회


## Question

이진 트리를 입력받아 전위 순회(preorder traversal), 중위 순회(inorder traversal), 후위 순회(postorder traversal)한 결과를 출력하는 프로그램을 작성하시오.

- 전위 순회한 결과 : (루트) (왼쪽 자식) (오른쪽 자식)  
- 중위 순회한 결과 : (왼쪽 자식) (루트) (오른쪽 자식)  
- 후위 순회한 결과 : (왼쪽 자식) (오른쪽 자식) (루트)  


### 입력
첫째 줄에는 이진 트리의 노드의 개수 N(1≤N≤26)이 주어진다. 둘째 줄부터 N개의 줄에 걸쳐 각 노드와 그의 왼쪽 자식 노드, 오른쪽 자식 노드가 주어진다. 노드의 이름은 A부터 차례대로 영문자 대문자로 매겨지며, 항상 A가 루트 노드가 된다. 자식 노드가 없는 경우에는 .으로 표현된다.


### 출력
첫째 줄에 전위 순회, 둘째 줄에 중위 순회, 셋째 줄에 후위 순회한 결과를 출력한다. 각 줄에 N개의 알파벳을 공백 없이 출력하면 된다.



## Solution
### 풀이 
```java
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.ArrayList;
import java.util.HashMap;

public class Main {
    public static void main(String args[]) throws Exception {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer(br.readLine());
        int nodeCount = Integer.parseInt(st.nextToken());
        
        HashMap<Character, Node> tree = new HashMap<Character, Node>(); // HashMap         
        
        for (int i = 1; i < nodeCount; i++)
        {
            st = new StringTokenizer(br.readLine());
            char root = st.nextToken().charAt(0);
            char left = st.nextToken().charAt(0);
            char right = st.nextToken().charAt(0);
            
            // System.out.println(root + " : " + left + " : " + right);
            
            tree.put(root, new Node(root, left, right));
        }
        
        preOrder(tree, 'A'); System.out.println("");
        inOrder(tree, 'A'); System.out.println("");
        postOrder(tree, 'A'); System.out.println("");
    }
    
    public static void preOrder(HashMap<Character, Node> tree, Character rootNode)
    {
        System.out.print(rootNode);
        
        if (tree.get(rootNode) != null && tree.get(rootNode).left != '.')
            preOrder(tree, tree.get(rootNode).left);
        
        if (tree.get(rootNode) != null && tree.get(rootNode).right != '.')
            preOrder(tree, tree.get(rootNode).right);
    }
    
    public static void inOrder(HashMap<Character, Node> tree, Character rootNode)
    {
        if (tree.get(rootNode) != null && tree.get(rootNode).left != '.')
            inOrder(tree, tree.get(rootNode).left);
            
        System.out.print(rootNode);
        
        if (tree.get(rootNode) != null && tree.get(rootNode).right != '.')
            inOrder(tree, tree.get(rootNode).right);
    }
    
    public static void postOrder(HashMap<Character, Node> tree, Character rootNode)
    {
        if (tree.get(rootNode) != null && tree.get(rootNode).left != '.')
            postOrder(tree, tree.get(rootNode).left);  
         
        if (tree.get(rootNode) != null && tree.get(rootNode).right != '.')
            postOrder(tree, tree.get(rootNode).right);
            
        System.out.print(rootNode);
    }
}
class Node { 
    char data; 
    char left; 
    char right; 
    
    public Node(char data, char left, char right) { 
        this.data = data; 
        this.left = left;
        this.right = right;
    } 
}
```
  


## Reference
- [BaekJoon](https://www.acmicpc.net/problem/1991)
