---
published: true
permalink: /algorithm/baekjoon-acmicpc-1904
comments: true
categories:
  - algorithm
title: '[BaekJoon] 1904. # 01타일'
---
[BaekJoon] 1904. # 01타일


## Question

지원이에게 2진 수열을 가르쳐 주기 위해, 지원이 아버지는 그에게 타일들을 선물해주셨다. 그리고 이 각각의 타일들은 0 또는 1이 쓰여 있는 낱장의 타일들이다.

어느 날 짓궂은 동주가 지원이의 공부를 방해하기 위해 0이 쓰여진 낱장의 타일들을 붙여서 한 쌍으로 이루어진 00 타일들을 만들었다. 결국 현재 1 하나만으로 이루어진 타일 또는 0타일을 두 개 붙인 한 쌍의 00타일들만이 남게 되었다.

그러므로 지원이는 타일로 더 이상 크기가 N인 모든 2진 수열을 만들 수 없게 되었다. 예를 들어, N=1일 때 1만 만들 수 있고, N=2일 때는 00, 11을 만들 수 있다. (01, 10은 만들 수 없게 되었다.) 또한 N=4일 때는 0011, 0000, 1001, 1100, 1111 등 총 5개의 2진 수열을 만들 수 있다.

우리의 목표는 N이 주어졌을 때 지원이가 만들 수 있는 모든 가짓수를 세는 것이다. 단 타일들은 무한히 많은 것으로 가정하자.


### 입력
첫 번째 줄에 자연수 N이 주어진다.(N ≤ 1,000,000)


### 출력
첫 번째 줄에 지원이가 만들 수 있는 길이가 N인 모든 2진 수열의 개수를 15746으로 나눈 나머지를 출력한다.


## Solution
### 풀이 
```java
import java.util.Scanner;
public class Main {
    public static void main(String[] args) {
        Scanner scn = new Scanner(System.in);
        int N = scn.nextInt();
        scn.close();
        // int[] tiles = new int[N + 1]; : 이렇게 될 경우, N =1인 경우 아래 tiles[2]에서 오류 발생하여 런타임 오류 발생 
        int[] tiles = new int[1000001];
        tiles[1] = 1; 
        tiles[2] = 2; 
        for (int i = 3; i < N + 1; i ++)
            tiles[i] = (tiles[i - 1] + tiles[i - 2]) % 15746; // 15746 처리 안할 경우 오버플로우 발생 
        System.out.println(tiles[N]);
    }
  	// 아래 함수 실행 시 시간 초과 발생 
    private static int getTileCount(int N) {
        if (N <= 2) 
            return N;
        return (getTileCount(N - 1) + getTileCount(N - 2))% 15746; 
    }
}
```


## Learning... 
- 재귀함수(`getTileCount`)로 실행히 시간초과 발생 
- `tiles`에 대해 [N + 1]로 지정할 경우, 밑에 tiles[2]에서 오류 발생 : 런타임 발생 
- 피보나치의 경우 int형에 대해서 처리 시 오버플로우 처리 필요 



## Reference
- [BaekJoon](https://www.acmicpc.net/problem/1904)
