---
permalink: /csharp/non-repeatable-data-hashset
title: "[C#] 중복값을 허용하지 않는 자료구조 (HashSet)"
comments: true
categories:
  - csharp
tags:
  - HashSet
---

중복값을 허용하지 않는 자료구조로 C#에서 활용할 수 있는 것으로는 HashSet가 있다.


## Reference

- [마이크로소프트 문서](https://docs.microsoft.com/en-us/dotnet/api/system.collections.generic.hashset-1?view=netframework-4.8) 


## Concept
(1) HashSet.Add (2019-07-28 작성) 

: HashSet.Add를 활용해서 중복 값 존재 여부를 확인할 수 있다.
- 리턴값이 true이면 현재 HashSet에 중복 값 없어 저장 가능
- 리턴값이 false이면 현재 HashSet에 중복 값이 있으므로 저장 불가능 

```c#
if (hashset.Add(value))
  // 삽입 가능 (= 중복되는 값 없음)
else
  // 삽입 불가능 (= 중복되는 값 있음) 
```

## Memo 
- [스택 오버플로우 : hashset와 list 성능비교] (https://stackoverflow.com/questions/150750/hashset-vs-list-performance)
