---
published: true
permalink: /csharp/stack
comments: true
categories:
  - csharp
tags:
  - stack
title: '[C#] 자료구조 : 스택(Stack)'
---
자료구조 : 스택(Stack) 

## Reference
### 속성
- Count : 스택에 포함된 요소 수 return 

### 메서드 
- Peek : 스택의 top 값 반환 
- Push : 스택에 추가 
- Pop : 스택의 top 값 제거하고 반환 


```c#
using System;
using System.Collections.Generic;					

public class Program
{
	public static void Main()
	{
		Stack<int> stack = new Stack<int>();

		Console.WriteLine("=====push=====");
		stack.Push(1); // 스택에 1 push 
		stack.Push(2); // 스택에 2 push
		Console.WriteLine("1,2 push 후 stack 개수 " + stack.Count);
		
		Console.WriteLine("=====pop=====");
		Console.WriteLine("pop : " + stack.Pop()); // 2 pop 
		Console.WriteLine("pop 후 stack 개수 " + stack.Count); // 2 -> 1 로 줄어듬 
		
		Console.WriteLine("=====peek=====");
		Console.WriteLine("peek : " + stack.Peek()); // 1 
		Console.WriteLine("peek 후 stack 개수 " + stack.Count);
	}
}
```
=> 결과  

![step2.png]({{site.baseurl}}/assets/images/csharp/stack_result.png){: width="=60%"}  
