---
permalink: /mssql/bit
title: "[mssql] Boolean 데이터 타입 (BIT)"
comments: true
categories:
  - mssql
tags:
  - BIT
  - sql server
---

Boolean형식을 mssql에서 사용하고 싶으면 ```BIT``` 데이터 형식을 사용하면 된다.

## Reference

- [스택 오버플로우 : Is there a Boolean data type in Microsoft SQL Server like there is in MySQL?](https://stackoverflow.com/questions/3138029/is-there-a-boolean-data-type-in-microsoft-sql-server-like-there-is-in-mysql) 
- [스택 오버플로우 : How do I select a 1 as a bit in a sql-server view?](https://stackoverflow.com/questions/3963457/how-do-i-select-a-1-as-a-bit-in-a-sql-server-view)

## Concept
```sql
DECLARE @b1 BIT = 'false'
PRINT @b1                    --prints 0

DECLARE @b2 BIT = 'true'
PRINT @b2                    --prints 1
```



- boolean형식으로 select하고 싶을때

```sql
SELECT id, name, CONVERT(BIT, 1) AS active
FROM users
```
